﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class RigidbodySynchronizer : MonoBehaviour
{
    [SerializeField] private Rigidbody target;

    private void Awake()
    {
        target = target.rigidbody;
        target.transform.parent = null;
    }

    private void LateUpdate()
    {
        if (target.transform.position != transform.position)
            target.MovePosition(transform.position);

        if (target.transform.rotation != transform.rotation)
            target.MoveRotation(transform.rotation);
    }
}

