﻿public class GamepadInputMixer : GamepadInput
{
    private GamepadInput gamepadInputA;
    private GamepadInput gamepadInputB;

    public void Initialize(GamepadInput gamepadInputA, GamepadInput gamepadInputB)
    {
        this.gamepadInputA = gamepadInputA;
        this.gamepadInputB = gamepadInputB;
    }

    public override bool GetButton(int gamepadIndex, Button button)
    {
        return gamepadInputA.GetButton(gamepadIndex, button) ||
               gamepadInputB.GetButton(gamepadIndex, button);
    }

    public override bool GetButtonDown(int gamepadIndex, Button button)
    {
        return gamepadInputA.GetButtonDown(gamepadIndex, button) ||
               gamepadInputB.GetButtonDown(gamepadIndex, button);
    }

    public override bool GetButtonUp(int gamepadIndex, Button button)
    {
        return gamepadInputA.GetButtonUp(gamepadIndex, button) ||
               gamepadInputB.GetButtonUp(gamepadIndex, button);
    }

    public override bool GetButton(Button button)
    {
        return gamepadInputA.GetButton(button) ||
               gamepadInputB.GetButton(button);
    }

    public override bool GetButtonDown(Button button)
    {
        return gamepadInputA.GetButtonDown(button) ||
               gamepadInputB.GetButtonDown(button);
    }

    public override bool GetButtonUp(Button button)
    {
        return gamepadInputA.GetButtonUp(button) ||
               gamepadInputB.GetButtonUp(button);
    }

    public override float GetAxis(int gamepadIndex, Axis axis)
    {
        return gamepadInputA.GetAxis(gamepadIndex, axis) +
               gamepadInputB.GetAxis(gamepadIndex, axis);
    }

    public override void SetLowestVibrationThisFrame(int gamepadIndex, float left, float right)
    {
        gamepadInputA.SetLowestVibrationThisFrame(gamepadIndex, left, right);
        gamepadInputB.SetLowestVibrationThisFrame(gamepadIndex, left, right);
    }
}
